-----------------------------------------------------------------------------

if not Aloft or not Aloft:HasModule("Polymorph") then return end
local AloftPolymorph = Aloft:GetModule("Polymorph")

local L = AceLibrary("AceLocale-2.2"):new("AloftPolymorphOptions")
local SML = AceLibrary("SharedMedia-1.0")
local SML_statusbar = SML:List("statusbar")

-----------------------------------------------------------------------------

L:RegisterTranslations("enUS", function() return {
	["Polymorph"] = true,
	["Polymorph options"] = true,

	["Enable"] = true,
	["Shows polymorph timers on nameplates when possible"] = true,
	["Speculative Attach"] = true,
	["Attempt to attach the polymorph timer bar when it is not absolutely certain if it is the correct nameplate"] = true,
	["Texture"] = true,
	["Sets the polymorph bar texture"] = true,
	["Colors"] = true,
	["Color options"] = true,
	["Bar Color"] = true,
	["Sets the polymorph bar color"] = true,
	["Backdrop Color"] = true,
	["Sets the polymorph backdrop color"] = true,
	["Size"] = true,
	["Polymorph size options"] = true,
	["Width"] = true,
	["Sets the width of the polymorph bar"] = true,
	["Height"] = true,
	["Sets the height of the polymorph bar"] = true,
	["Position"] = true,
	["Adjust polymorph bar position"] = true,
	["Anchor"] = true,
	["Sets the anchor for the polymorph bar"] = true,
	["Anchor To"] = true,
	["Sets the relative point on the health bar to anchor the polymorph bar"] = true,
	["X Offset"] = true,
	["X offset of the polymorph bar"] = true,
	["Y Offset"] = true,
	["Y offset of the polymorph bar"] = true,
} end)

L:RegisterTranslations("koKR", function() return {
	["Polymorph"] = "변이",
	["Polymorph options"] = "변이 설정",

	["Enable"] = "사용",
	["Shows polymorph timers on nameplates when possible"] = "가능할 때 이름표에 변이 타이머를 표시합니다.",
	["Speculative Attach"] = "추리적인 붙이기",
	["Attempt to attach the polymorph timer bar when it is not absolutely certain if it is the correct nameplate"] = "정확한 이름표가 확실치 않을때 변이 타이머바 붙이기를 시도합니다.",
	["Texture"] = "텍스쳐",
	["Sets the polymorph bar texture"] = "변이바의 텍스쳐를 설정합니다.",
	["Colors"] = "색상",
	["Color options"] = "색상 설정",
	["Bar Color"] = "바 색상",
	["Sets the polymorph bar color"] = "변이바의 색상을 설정합니다.",
	["Backdrop Color"] = "배경 색상",
	["Sets the polymorph backdrop color"] = "변이바의 배경 색상을 설정합니다.",
	["Size"] = "크기",
	["Polymorph size options"] = "변이 크기 설정",
	["Width"] = "너비",
	["Sets the width of the polymorph bar"] = "변이바의 너비를 설정합니다.",
	["Height"] = "높이",
	["Sets the height of the polymorph bar"] = "변이바의 높이를 설정합니다.",
	["Position"] = "위치",
	["Adjust polymorph bar position"] = "변이바의 위치를 조절합니다.",
	["Anchor"] = "앵커",
	["Sets the anchor for the polymorph bar"] = "변이바의 앵커를 설정합니다.",
	["Anchor To"] = "앵커 위치",
	["Sets the relative point on the health bar to anchor the polymorph bar"] = "생명력바에서 변이바 앵커 위치를 설정합니다.",
	["X Offset"] = "X 좌표",
	["X offset of the polymorph bar"] = "변이바의 X 좌표입니다.",
	["Y Offset"] = "Y 좌표",
	["Y offset of the polymorph bar"] = "변이바의 Y 좌표입니다.",
} end)

-----------------------------------------------------------------------------

Aloft.Options.args.polymorph =
{
	type = 'group',
	name = L["Polymorph"],
	desc = L["Polymorph options"],
	disabled = function() return not Aloft:IsActive() end,
	args =
	{
		enable =
		{
			type = 'toggle',
			name = L["Enable"],
			desc = L["Shows polymorph timers on nameplates when possible"],
			get = function() return AloftPolymorph.db.profile.enable end,
			set = function(v) AloftPolymorph.db.profile.enable = v AloftPolymorph:UpdateAll() end,
			order = 1
		},
		speculativeAttach =
		{
			type = 'toggle',
			name = L["Speculative Attach"],
			desc = L["Attempt to attach the polymorph timer bar when it is not absolutely certain if it is the correct nameplate"],
			disabled = function() return not AloftPolymorph.db.profile.enable end,
			get = function() return AloftPolymorph.db.profile.speculativeAttach end,
			set = function(v) AloftPolymorph.db.profile.speculativeAttach = v end,
			order = 2
		},
		texture =
		{
			type = "text", 
			name = L["Texture"], 
			desc = L["Sets the polymorph bar texture"],
			disabled = function() return not AloftPolymorph.db.profile.enable end,
			get = function() return AloftPolymorph.db.profile.texture end,
			set = function(v) AloftPolymorph.db.profile.texture = v AloftPolymorph:UpdateAll() end,
			validate = SML_statusbar
		},
		colors =
		{
			type = 'group',
			name = L["Colors"],
			desc = L["Color options"],
			disabled = function() return not AloftPolymorph.db.profile.enable end,
			args =
			{
				bar =
				{
					type = 'color',
					name = L["Bar Color"],
					desc = L["Sets the polymorph bar color"],
					get = function() return unpack(AloftPolymorph.db.profile.color) end,
					set = function(r, g, b, a) AloftPolymorph.db.profile.color = { r, g, b, a } AloftPolymorph:UpdateAll() end,
					hasAlpha = true,
					order = 1
				},
				backdrop =
				{
					type = 'color',
					name = L["Backdrop Color"],
					desc = L["Sets the polymorph backdrop color"],
					get = function() return unpack(AloftPolymorph.db.profile.backdropColor) end,
					set = function(r, g, b, a) AloftPolymorph.db.profile.backdropColor = { r, g, b, a } AloftPolymorph:UpdateAll() end,
					hasAlpha = true,
					order = 2
				},
			},
		},
		size =
		{
			type = 'group',
			name = L["Size"],
			desc = L["Polymorph size options"],
			disabled = function() return not AloftPolymorph.db.profile.enable end,
			args =
			{
				width =
				{
					type = 'range',
					name = L["Width"],
					desc = L["Sets the width of the polymorph bar"],
					min = 5,
					max = 250,
					step = 1,
					get = function() return AloftPolymorph.db.profile.width end,
					set = function(v) AloftPolymorph.db.profile.width = v AloftPolymorph:UpdateAll() end
				},
				height =
				{
					type = 'range',
					name = L["Height"],
					desc = L["Sets the height of the polymorph bar"],
					min = 2,
					max = 32,
					step = 1,
					get = function() return AloftPolymorph.db.profile.height end,
					set = function(v) AloftPolymorph.db.profile.height = v AloftPolymorph:UpdateAll() end
				},
			},
		},
		position =
		{
			type = 'group',
			name = L["Position"],
			desc = L["Adjust polymorph bar position"],
			disabled = function() return not AloftPolymorph.db.profile.enable end,
			args =
			{
				anchor = {
					type = "text", 
					name = L["Anchor"], 
					desc = L["Sets the anchor for the polymorph bar"],
					get = function() return AloftPolymorph.db.profile.point end,
					set = function(v) AloftPolymorph.db.profile.point = v AloftPolymorph:UpdateAll() end,
					validate = {"TOPLEFT", "TOP", "TOPRIGHT", "LEFT", "CENTER", "RIGHT", "BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT"},
				},
				anchorto = {
					type = "text", 
					name = L["Anchor To"], 
					desc = L["Sets the relative point on the health bar to anchor the polymorph bar"],
					get = function() return AloftPolymorph.db.profile.relativeToPoint end,
					set = function(v) AloftPolymorph.db.profile.relativeToPoint = v AloftPolymorph:UpdateAll() end,
					validate = {"TOPLEFT", "TOP", "TOPRIGHT", "LEFT", "CENTER", "RIGHT", "BOTTOMLEFT", "BOTTOM", "BOTTOMRIGHT"},
				},
				offsetX =
				{
					type = 'range',
					name = L["X Offset"],
					desc = L["X offset of the polymorph bar"],
					min = -32,
					max = 32,
					step = 1,
					get = function() return AloftPolymorph.db.profile.offsetX end,
					set = function(v) AloftPolymorph.db.profile.offsetX = v AloftPolymorph:UpdateAll() end
				},
				offsetY =
				{
					type = 'range',
					name = L["Y Offset"],
					desc = L["Y offset of the polymorph bar"],
					min = -32,
					max = 32,
					step = 1,
					get = function() return AloftPolymorph.db.profile.offsetY end,
					set = function(v) AloftPolymorph.db.profile.offsetY = v AloftPolymorph:UpdateAll() end
				},
			},
		},
	},
}

-----------------------------------------------------------------------------
