-----------------------------------------------------------------------------

if not Aloft or not Aloft:HasModule("ThreatBar") then return end
local AloftThreatBar = Aloft:GetModule("ThreatBar")
local L = AceLibrary("AceLocale-2.2"):new("AloftThreatBarOptions")
local SML = AceLibrary("SharedMedia-1.0")
local SML_statusbar = SML:List("statusbar")

-----------------------------------------------------------------------------

L:RegisterTranslations("enUS", function() return {
	["Threat Bar"] = true,
	["Threat Bar options"] = true,
	["Enable"] = true,
	["Show threat bars on group member nameplates"] = true,

	["Texture"] = true,
	["Sets the threat bar texture"] = true,
	["Alpha"] = true,
	["Sets the threat bar alpha"] = true,

	["Height"] = true,
	["Sets the height of the threat bar"] = true,
	
	["Position"] = true,
	["Adjust the threat bar's position"] = true,
	["Left Offset"] = true,
	["Sets the offset of the left of the threat bar"] = true,
	["Right Offset"] = true,
	["Sets the offset of the right of the threat bar"] = true,
	["Vertical Offset"] = true,
	["Sets the vertical offset of the threat bar"] = true,
	
	["Colors"] = true,
	["Customize colors"] = true,
	["Maximum Threat Common Color"] = true,
	["Sets the color for threat shared when you have the maximum threat on a unit."] = true,
	["Maximum Threat Margin Color"] = true,
	["Sets the color for the threat before someone matches your threat level."] = true,
	["Common Threat Color"] = true,
	["Sets the color for your threat level when you do not have maximum threat."] = true,
	["Common Threat Margin Color"] = true,
	["Sets the color for the threat remaining until you match the highest threat."] = true,

	["Reset to Defaults"] = true,
	["Resets all colors to their defaults"] = true,

	["Advanced"] = true,
	["Options for expert users"] = true,
	["Color Format"] = true,
	["Color tag"] = true,
	["<Any tag string>"] = true,
} end)

-----------------------------------------------------------------------------

Aloft.Options.args.manaBar =
{
	type = 'group',
	name = L["Threat Bar"],
	desc = L["Threat Bar options"],
	disabled = function() return not Aloft:IsActive() end,
	args =
	{
		enable =
		{
			type = 'toggle',
			name = L["Enable"],
			desc = L["Show threat bars on group member nameplates"],
			get = function() return AloftThreatBar.db.profile.enable end,
			set = function(v) AloftThreatBar.db.profile.enable = v Aloft:DetermineDataSources() AloftThreatBar:UpdateAll() end,
			order = 1
		},
		texture =
		{
			type = "text", 
			name = L["Texture"], 
			desc = L["Sets the threat bar texture"],
			get = function() return AloftThreatBar.db.profile.texture end,
			set = function(v) AloftThreatBar.db.profile.texture = v AloftThreatBar:UpdateAll() end,
			disabled = function() return not AloftThreatBar.db.profile.enable end,
			validate = SML_statusbar
		},
		position =
		{
			type = 'group',
			name = L["Position"],
			desc = L["Adjust the threat bar's position"],
			disabled = function() return not AloftThreatBar.db.profile.enable end,
			args =
			{
				left =
				{
					type = 'range',
					name = L["Left Offset"],
					desc = L["Sets the offset of the left of the threat bar"],
					min = -32,
					max = 32,
					step = 1,
					get = function() return AloftThreatBar.db.profile.offsets.left end,
					set = function(v) AloftThreatBar.db.profile.offsets.left = v AloftThreatBar:UpdateAll() end
				},
				right =
				{
					type = 'range',
					name = L["Right Offset"],
					desc = L["Sets the offset of the right of the threat bar"],
					min = -32,
					max = 32,
					step = 1,
					get = function() return AloftThreatBar.db.profile.offsets.right end,
					set = function(v) AloftThreatBar.db.profile.offsets.right = v AloftThreatBar:UpdateAll() end
				},
				vertical =
				{
					type = 'range',
					name = L["Vertical Offset"],
					desc = L["Sets the vertical offset of the threat bar"],
					min = -32,
					max = 32,
					step = 1,
					get = function() return AloftThreatBar.db.profile.offsets.vertical end,
					set = function(v) AloftThreatBar.db.profile.offsets.vertical = v AloftThreatBar:UpdateAll() end
				},
			},
		},
		height =
		{
			type = 'range',
			name = L["Height"],
			desc = L["Sets the height of the threat bar"],
			min = 2,
			max = 32,
			step = 1,
			disabled = function() return not AloftThreatBar.db.profile.enable end,
			get = function() return AloftThreatBar.db.profile.height end,
			set = function(v) AloftThreatBar.db.profile.height = v AloftThreatBar:UpdateAll() end
		},
		colors =
		{
			type = 'group',
			name = L["Colors"],
			desc = L["Customize colors"],
			disabled = function() return not AloftThreatBar.db.profile.enable end,
			args =
			{
				maxThreatCommonColor =
				{
					type = 'color',
					name = L["Maximum Threat Common Color"],
					desc = L["Sets the color for threat shared when you have the maximum threat on a unit."],
					get = function() return unpack(AloftThreatBar.db.profile.maxThreatCommonColor) end,
					set = function(r, g, b, a) AloftThreatBar.db.profile.maxThreatCommonColor = { r, g, b, a } AloftThreatBar:UpdateAll() end,
					hasAlpha = true,
					order = 1
				},
				maxThreatMarginColor =
				{
					type = 'color',
					name = L["Maximum Threat Margin Color"],
					desc = L["Sets the color for the threat before someone matches your threat level."],
					get = function() return unpack(AloftThreatBar.db.profile.maxThreatMarginColor) end,
					set = function(r, g, b, a) AloftThreatBar.db.profile.maxThreatMarginColor = { r, g, b, a } AloftThreatBar:UpdateAll() end,
					hasAlpha = true,
					order = 1
				},
				commonThreatColor =
				{
					type = 'color',
					name = L["Common Threat Color"],
					desc = L["Sets the color for your threat level when you do not have maximum threat."],
					get = function() return unpack(AloftThreatBar.db.profile.commonThreatColor) end,
					set = function(r, g, b, a) AloftThreatBar.db.profile.commonThreatColor = { r, g, b, a } AloftThreatBar:UpdateAll() end,
					hasAlpha = true,
					order = 1
				},
				commonThreatMarginColor =
				{
					type = 'color',
					name = L["Common Threat Margin Color"],
					desc = L["Sets the color for the threat remaining until you match the highest threat."],
					get = function() return unpack(AloftThreatBar.db.profile.commonThreatMarginColor) end,
					set = function(r, g, b, a) AloftThreatBar.db.profile.commonThreatMarginColor = { r, g, b, a } AloftThreatBar:UpdateAll() end,
					hasAlpha = true,
					order = 1
				},
				reset =
				{
					type = "execute",
					name = L["Reset to Defaults"],
					desc = L["Resets all colors to their defaults"],
					order = -1,
					func  = function() 
								AloftThreatBar.db.profile.maxThreatCommonColor	= { 1, 1, 1, 1 }
								AloftThreatBar.db.profile.maxThreatMarginColor	= { 0, 1, 0, 1 }
								AloftThreatBar.db.profile.commonThreatColor		= { 1, 1, 1, 1 }
								AloftThreatBar.db.profile.commonThreatMarginColor	= { 1, 0, 0, 1 }
								
								AloftThreatBar:UpdateAll()
							end,
				},
			}
		}
	},
}

-----------------------------------------------------------------------------
